using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Web.UI.WebControls.Tools;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Init(object sender, EventArgs e)
    {
        this.AccessDataSource1.DataFile = Server.MapPath("\\Syncfusion\\Web\\Data\\NWind.MDB");
        //Add PrimaryKey to the PrimaryKeyColumns collection 
        GridTableDescriptor mainTD = this.GridGroupingControl1.TableDescriptor;
        mainTD.PrimaryKeyColumns.Add("EmployeeID");
        //Call DataBind 
        this.GridGroupingControl1.DataBind();

        ButtonBar bar = this.GridGroupingControl1.ButtonBars[0] as ButtonBar;
        ((ButtonBarItem)bar.BarItems[0]).ImageUrl = this.GridGroupingControl1.Images.GetBtnEdit();
        ((ButtonBarItem)bar.BarItems[1]).ImageUrl = this.GridGroupingControl1.Images.GetBtnSave();
        ((ButtonBarItem)bar.BarItems[2]).ImageUrl = this.GridGroupingControl1.Images.GetBtnCancel();

        //these events will be triggered when user Add , delete or update a row.
        this.GridGroupingControl1.DataSourceControlRowDeleting += new GridDataSourceControlRowDeleteEventHandler(this.RowDeleting);
        this.GridGroupingControl1.DataSourceControlRowAdding += new GridDataSourceControlRowAddingEventHandler(this.RowAdding);
        this.GridGroupingControl1.DataSourceControlRowUpdating += new GridDataSourceControlRowUpdateEventHandler(this.RowUpdating);
    }

    #region Editing Support
    private bool EditMode
    {
        get
        {
            object editMode = this.ViewState["EditMode"];
            return editMode == null ? false : (bool)editMode;
        }
        set
        {
            if (value == false)
                this.ViewState.Remove("EditMode");
            else
                this.ViewState["EditMode"] = true;
        }
    }

    // 1) On Page_Load we determine if the page is currently in EditMode, if not we remove the templates (and cache them somewhere).
    //		The grid will then create it's internal controls reflecting the latest state. 
    // 2) If the user had then clicked on one of the bar buttons, that would trigger BarButtonItemClicked event, which will change the EditMode setting.
    //		This step will also cause changes made, if any, by the user to be saved into the datasource.
    // 3) Then in PreRender event, we again check if EditMode is set and make sure that the templates are available and if 
    //		EditMode is not set, remove the templates.

    private ArrayList templatesList = new ArrayList();
    protected void Page_Load(object sender, EventArgs e)
    {
        // If the grid is currently not in edit mode
        if (this.EditMode == false)
        {
            foreach (GridVisibleColumnDescriptor gvcd in this.GridGroupingControl1.TableDescriptor.VisibleColumns)
            {
                GridColumnDescriptor gcd = this.GridGroupingControl1.TableDescriptor.Columns.FindByMappingName(gvcd.Name);
                // Save the template for now.
                templatesList.Add(gcd.ItemTemplate);
                // Remove the editing template since currently the grid is not in edit mode.
                gcd.ItemTemplate = null;
            }
        }
    }
    protected void Page_PreRender(object sender, EventArgs e)
    {
        foreach (GridVisibleColumnDescriptor gvcd in this.GridGroupingControl1.TableDescriptor.VisibleColumns)
            {
                GridColumnDescriptor gcd = this.GridGroupingControl1.TableDescriptor.Columns.FindByMappingName(gvcd.Name);
                if (this.EditMode)
                {
                    // If the grid is in edit more and the templates are not there (maybe b'cos we removed them in the Page_Load),
                    // add them again.
                    if (gcd.ItemTemplate == null)
                    {
                        // Set the template on the columns to allow editing
                        gcd.ItemTemplate = templatesList[0] as ITemplate;
                        templatesList.RemoveAt(0);
                    }
                }
                else
                {
                    // If the grid is currently not in edit mode, make sure to remove the template
                    gcd.ItemTemplate = null;
                }
            }
         //After adding the Item template to GridColumnDescriptor, EditMode should set to false, to avoid adding Itemtemplate once again on postbacks.
         this.EditMode = false; 
    }
    protected void GridGroupingControl1_BarButtonItemClicked(object source, ButtonBarItemClickEventArgs e)
    {
        ButtonBar buttonbar = (ButtonBar)this.GridGroupingControl1.ButtonBars[0];
        BarItem editButton = (BarItem)buttonbar.BarItems[0];
        BarItem saveButton = (BarItem)buttonbar.BarItems[1];
        BarItem cancelButton = (BarItem)buttonbar.BarItems[2];
        if (e.ButtonBarItem.Tooltip == "Start Edit")
        {
            this.StartEditing();
            editButton.Visible = false;
            saveButton.Visible = true;
            cancelButton.Visible = true;
            e.Handled = true;
        }
        else if (e.ButtonBarItem.Tooltip == "Save Changes")
        {
            this.SaveChanges();
            editButton.Visible = true;
            saveButton.Visible = false;
            cancelButton.Visible = false;
            e.Handled = true;
        }
        else if (e.ButtonBarItem.Tooltip == "Cancel Changes")
        {
            this.CancelChanges();
            editButton.Visible = true;
            saveButton.Visible = false;
            cancelButton.Visible = false;
            e.Handled = true;
        }
    }
    private void StartEditing()
    {
        this.EditMode = true;
    }

    private void SaveChanges()
    {
        // Parse through all the rows in the grid table
        foreach (TableRow row in this.GridGroupingControl1.TopLevelTable.Rows)
        {
            if (row is GridRow)
            {
                GridRow gridRow = row as GridRow;
                // Skip all non record rows.
                if (gridRow.Record != null)
                {
                    Record record = gridRow.Record;

                    record.BeginEdit();
                    // Parse through all the cells in the row, skipping the first, which is the row header.
                    bool skippedFirst = false;
                    foreach (GridCell gridCell in gridRow.Cells)
                    {
                        if (!skippedFirst) { skippedFirst = true; continue; }

                        // The HomePhone column uses a MaskedEditTextBox
                        if (gridCell.ColumnDescriptor.Name == "HomePhone")
                        {
                            MaskedEditTextBox tb = null;
                            foreach (Control c in gridCell.Controls)
                            {
                                if (c is MaskedEditTextBox) { tb = c as MaskedEditTextBox; break; }
                            }
                            // Set the new value based on the current value in the textbox.
                            record.SetValue(gridCell.ColumnDescriptor.MappingName, tb.Text);
                        }
                        // The rest of the columns use a TextBox.
                        else if (gridCell.ColumnDescriptor.Name != "EmployeeID")
                        {
                            TextBox tb = null;
                            foreach (Control c in gridCell.Controls)
                            {
                                if (c is TextBox) { tb = c as TextBox; break; }
                            }
                            // Verify that the user provided a valid format for this date.
                            if (gridCell.ColumnDescriptor.Name == "BirthDate")
                            {
                                bool validString = true;
                                try
                                {
                                    DateTime.Parse(tb.Text);
                                }
                                catch
                                {
                                    validString = false;
                                }
                                if (validString == false)
                                    continue;
                            }
                            // Set the new value based on the current value in the textbox.
                            record.SetValue(gridCell.ColumnDescriptor.MappingName, tb.Text);
                        }
                    }
                    record.EndEdit();
                }
            }
        }
        this.EditMode = false;
    }

    private void CancelChanges()
    {
        this.EditMode = false;
    }

    // Get the value to be displayed in the textboxes.
    protected string GetFieldText(GridCell gridCell)
    {
        return gridCell.StyleInfo.FormattedText;
    }

    protected string GetMask(GridCell gridCell)
    {
        GridRow grow = gridCell.Row;
        string countryValue = grow.Record.GetValue("Country").ToString();
        if (countryValue == "UK")
            return "(##) ###-####";
        else//USA
            return "(###) ###-####";
    }
    #endregion

    // We cancel the Adding,Deleting,Updating the datasource in the following events in order to prevent changes to the data source in samples, 
    //also prevents from throwing an exception because the update command is not specified in  datasource properly.
    #region Prevent updation in datasource
    private void RowUpdating(object sender, GridDataSourceControlRowUpdateEventArgs e)
    {
        e.Cancel = true;
    }
    private void RowAdding(object sender, GridDataSourceControlRowAddingEventArgs e)
    {
        e.Cancel = true;
    }

    private void RowDeleting(object sender, GridDataSourceControlRowDeleteEventArgs e)
    {
        e.Cancel = true;
    }
    #endregion
}
